/**
 * 公共函数js文件
 */


// ----------------------------------------------------------------------------------------
/**
 * 获取话题列表
 */
var getTopicData = function(num) {
    api.execScript({
        frameName: 'home',
        script: 'getTopicListData(' + num + ')'
    });
};


// ----------------------------------------------------------------------------------------
/**
 * 打开话题详情
 */
var openTopicDetail = function(url,para_data,template_element_id,target_element_id) {
    api.execScript({
        frameName: 'fram_topicDetil',
        script: 'putDataInHtmlOne('+url+','+para_data+','+template_element_id+','+target_element_id+')'
    });
};


// ----------------------------------------------------------------------------------------
/**
 * 退出应用
 */
function exitApp() {
    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        api.toast({
            msg: '再按一次返回键退出' + api.appName,
            duration: 2000,
            location: 'bottom'
        });
        api.addEventListener({
            name: 'keyback'
        }, function(ret, err) {
            api.closeWidget({
                id: 'A6924650424905',
                retData: { name: 'closeWidget' },
                silent: true
            });
        });
        setTimeout(function() {
            exitApp();
        }, 3000)
    });
}


//-----------------------------------------------------------------------
/**
 * 公共类
 */
(function(window) {
    var z = {};
    //------------------------------------------------------------------
    /**
     * 获取话题标题和内容
     * 参数：
     * @param {String} str
     * 返回数据：
     * @param {Object} {topic: '...', content: '...'}
     */
    z.getTopicCon = function(str) {
        var _str = str.trim();
        if(_str.indexOf('#') == 0) {
            var _2 = _str.substring(1, _str.length).indexOf('#');
            if(_2 > -1) {
                return {
                    topic: _str.substring(1, _2+1),
                    content: _str.substring(_2+2, _str.length)
                }
            }
        }
        return {
            topic: '',
            content: _str
        }
    };
    //------------------------------------------------------------------
    /**
     * 格式化标准时间
     * 参数：
     * @param {String} str
     * 返回数据：
     * @param {String}
     */
    z.formatTime = function(v) {
        var t = {
            y : v.getFullYear(),
            m : v.getMonth() + 1 < 10 ? ('0' + v.getMonth() + 1) : v.getMonth() + 1,
            d : v.getDate() < 10 ? ('0' + v.getDate()) : v.getDate(),
            h : v.getHours() < 10 ? ('0' + v.getHours()) : v.getHours(),
            mi : v.getMinutes() < 10 ? ('0' + v.getMinutes()) : v.getMinutes(),
            s : v.getSeconds() < 10 ? ('0' + v.getSeconds()) : v.getSeconds()
        };

        return t.y + '-' + t.m + '-' + t.d + ' ' + t.h + ':' + t.mi + ':' + t.s;
    };

    //----------------------------------------------------------------
    /**
     * 设置匿名身份和头像,存放localStorage中
     */
    z.setUserInfo = function(userId,descId){
        var userInfo={}
        userInfo.nickname=desc_config[descId]+user_config[userId].nickname;
        userInfo.avatar=user_config[userId].avatar;
        localStorage.setItem("user-random",JSON.stringify(userInfo));
        //console.log(localStorage.getItem("user-random"));
    };

    //----------------------------------------------------------------
    /**
     * 以时间戳为种子产生随机数
     * @param {Object} v
     */
    z.randByTime = function(v) {
        return Date.parse(new Date()) / 1000 % v;
    };

    //----------------------------------------------------------------
    /**
     * 以数组方式产生随机数
     */
    z.randByArray = function(v) {
        var orArr = new Array;
        // 数组赋值
        for(var i = 0; i < v; ++i) {
            orArr[i] = i;
        }
        orArr.sort(function() {
            return 0.5 - Math.random();
        });
        return orArr[0];
    };

    //----------------------------------------------------------------
    /**
     * 计算某时间过去了多少秒多少分钟多少小时,传精确到秒时间戳
     */
    z.postTime = function(postTime){
        var time=(Date.parse(new Date())/1000);
        var time_old=time-postTime;
        var retData="";
        if(time_old<60){
            retData=time_old+"秒前";
        }else if(time_old<3600){
            retData=(time_old/60).toFixed(0)+"分钟前";
        }else if(time_old<86400){ //一天
          /*这里不能用toFixed()等,因禁止4舍5入,23.8小时不能成为24小时,也禁止出现23小时60分钟的情况
          var hour=parseInt(86380/3600);
          var minute=parseInt(86380/60)-(hour*60);
          console.log();
          */
          var hour=parseInt(time_old/3600);
          var minute=parseInt(time_old/60)-(hour*60);
          retData=hour+"小时"+minute+"分钟前";
        }else if(time_old<2592000){//2592000一个月
          var day=parseInt(time_old/86400);
          retData=day+"天前";
        }
      return retData;
    };
    window.$z = z;
})(window);

//-----------------------------------------------------------------
/**
 * 服务器端取出的数据在做一次格式转换
 * @author:李欣
 * 用法示例:console.log(new Date(data[i].createdAt).format("yyyy-MM-dd hh:mm:ss"));
 */
Date.prototype.format = function (fmt) { //author: meizz
    var o = {
      "M+": this.getMonth() + 1, //月份
      "d+": this.getDate(), //日
      "h+": this.getHours(), //小时
      "m+": this.getMinutes(), //分
      "s+": this.getSeconds(), //秒
      "q+": Math.floor((this.getMonth() + 3) / 3), //季度
      "S": this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
      if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

//---------------------------------------------------------------------
/**
 * 转换字符串长度
 * @杨涛元
 */
function convertStrLen(content) {
    var len_cn = 0,
        len_en = 0;
    for (var i = 0; i < content.length; i++) {
        if (content.charCodeAt(i) > 127 || content.charCodeAt(i) == 94) {
            len_cn++;
        } else {
            len_en++;
        }
    }
    if (len_en % 2 !== 0) {
        len_en = (len_en + 1) / 2;
    } else {
        len_en = len_en / 2;
    }
    return len_cn + len_en;
}