apiready = function() {
    api.parseTapmode();

    // 获取话题列表函数
    getTopicListData(pageStart);

    // 下拉刷新
    api.setRefreshHeaderInfo({
        visible: true,
        loadingImg: 'widget://image/refresh.png',
        bgColor: '#ccc',
        textColor: '#fff',
        textDown: '下拉刷新...',
        textUp: '松开刷新...',
        showTime: true,
    }, function(ret, err) {
        getTopicListData(pageStart);
        api.refreshHeaderLoadDone();
    });

    // 上拉加载
    api.addEventListener({
        name: 'scrolltobottom',
        extra:{
            threshold: 10           //设置距离底部多少距离触发
        }
    }, function(ret, err) {
        counter++;
        num = counter * pageStart;
        getTopicListData(num);
    });

}


// 自定义变量
var pageStart = 10,
    counter = 0,
    num = 0;

//-------------------------------------------------------------------------
/**
 * 获取话题列表
 * @auhor zlh
 * @param num
 */
function getTopicListData(num) {
    api.ajax({
        url: config.dev_url + 'topic/recent_list',
        method: 'post',
        data: {
            values: {
                num: num,
            },
        }
    }, function(ret, err) {
        if (ret) {
            var data = ret.data;
            var html = "";
            for (i = 0; i < data.length; i++) {
                var time = $z.postTime(data[i].create_timestamp);
                if (time != "") {
                    data[i].updatedAt = time;
                }
                data[i].headimg = user_config[data[i].headimg].avatar;
                var tmpl = $api.dom('#topic_list_temp').innerHTML;
                var doTtmpl = doT.template(tmpl);
                html += doTtmpl(data[i]);
            }
            $api.html($api.dom('#topic_list'), html);
            fillTopicData(data);
        } else {
            api.alert({ msg: JSON.stringify(err) });
        }
    });
}

//-------------------------------------------------------------------
/**
 * 填充话题列表赞和评论
 * @auhor zlh
 * @param data [json数组]
 */
function fillTopicData(data) {
    var topic_comments = $api.domAll('span.topic-comments');
    var topic_praises = $api.domAll('span.topic-praises');
    for (var i = 0; i < data.length; i++) {
        if (data[i].praise_cnt == 0) {
            $api.text(topic_praises[i], '赞');
        } else {
            $api.text(topic_praises[i], data[i].praise_cnt);
        }
        if (data[i].comment_cnt == 0) {
            $api.text(topic_comments[i], '评论');
        } else {
            $api.text(topic_comments[i], data[i].comment_cnt);
        }
    };
}

//---------------------------------------------------------------------
/**
 * 打开话题详情窗口
 * @auhor zlh
 * @param id
 */
function openTopicDetails(id) {
    api.openWin({
        name: 'win_topic_details',
        url: 'win_topic_details.html',
        bounces: false,
        showProgress: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        delay: 200,
        pageParam: {
            topic_id: id
        }
    });
}

//-------------------------------------------------------------------
/**
 * 更多菜单
 * @auhor zlh
 * description: [微信分享,复制,收藏,举报]
 */
function moreMenu(topic_id, user_id) {
    api.openFrame({
        name: 'moremenu',
        url: './more_menu.html',
        bounces: false,
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        },
        pageParam: {
            topic_id: topic_id,
            user_id: user_id
        }
    });
    api.bringFrameToFront({
        from: 'moremenu'
    });
}