//自定义对象
var data = {};
//记录点赞时间,点赞不用刷新页面,不用缓存数据
var timeInterval=0;

//--------------------------------------------------------------------
/**
 * 取得发表评论时所必须的参数,写要这个页面的取得话题详情回调之后才可获取
 * @param  {[type]} data [description]
 * @return {[type]}      [description]
 */
function getCommentData(data) {
   /**
    * 获取单个话题得到的数据(测试需要用到的数据)
    * type data
    * 返回话题数据格式={"updatedAt":"2016-11-19T13:41:12.000Z",
     "content":"国化asdfsa越来越大本dfsd ","id":36,
     "title":"s asdf阿斯蒂芬asdf塔顶 ",
     "comment_cnt":0,"nickname":"炸毛的牛魔王",
     "createdAt":"2016-11-19T1","headimg":38,
     "create_timestamp":1479562872, "user_id":600,
     "praise_cnt":0}
    */
    localStorage.setItem("comment-topic-userid", data.user_id);
    localStorage.setItem("comment-level", "1"); //一级评论
    localStorage.setItem("comment-parentId", "");
}

//--------------------------------------------------------------------
/**
 * 向服务器新增一个浏览记录
 * @param data
 */
function createBrowseHistory(data) {
    api.ajax({
        url: config.dev_url + 'browse_record/create',
        method: 'post',
        data: {
            values: {
                "user_id": localStorage.getItem("user-id"),
                "topic_id": data.id
            }
        }
    }, function(ret, err) {
        if (ret) {
            console.log("新加历史记录结果"+JSON.stringify(ret));
        }
    });
}

//------------------------------------------------------------------
/**
 * 获取话题详情
 * @auhor zlh
 * @param id
 */
function getTopicDetails(id) {
    api.ajax({
        url: config.dev_url + 'topic/find',
        method: 'post',
        data: {
            values: { "id": id },
        }
    }, function(ret, err) {
        if (ret) {
            var data = ret.data;
            getCommentData(data);
            createBrowseHistory(data);

            var curr_user_id = localStorage.getItem("user-id");
            data.curr_user_id = curr_user_id; //当前登录的用户ID

            var time = $z.postTime(data.create_timestamp);
            if (time != "") { data.updatedAt = time; }
            data.headimg = user_config[data.headimg].avatar;
            var topic_temp = doT.template($api.dom('#topic-detail-data').innerHTML);
            $api.dom('#topic_master').innerHTML = topic_temp(data);
            queryIsPraised(curr_user_id,data.id,'topic');
            //显示话题详情中的图片
            topicDetailPhoto(data);
        }
    });
}

//-------------------------------------------------------------------
/**
 * 检查用户是否已经点赞话题或评论
 * @author:？
 * @param user_id
 * @param data_id
 * @param type
 */
function queryIsPraised(user_id,data_id,type){
   var postParams = {};
   var laud = null;
   postParams.user_id = user_id;
   if(type=='topic'){
     postParams.topic_id = data_id;
     laud = $api.byId('laud-id-'+data_id);
    }else{
     postParams.comment_id = data_id; 
     //这里不用laud-comment-id
     laud = $api.byId('praise-comment-id-'+data_id);
       //laud=$api.byId('praise-comment-id-115"; praise-comment-id-117
       console.log("s:"+'praise-comment-id-'+data_id+" "+$api.byId('praise-comment-id-'+data_id));
   }
   api.ajax({
    url: config.dev_url + 'praise/is_praised',
    method: 'post',
    data: {
        values: postParams,
    }
  }, function(ret, err){
    console.log(JSON.stringify(ret)+" "+user_id+" "+data_id);
    if (ret.is_praised === 1) {
        $api.addCls(laud, 'praise-color');
        console.log("t:"+$api.attr(laud,"id"));
    }
   });
}

//-----------------------------------------------------------------
/**
 * 点赞时间控制三秒
 * @author:hj
 */
function pariseTimeInterval(){
    var time=(Date.parse(new Date())/1000);
    if((time-timeInterval)<3) {
        api.toast({ msg: '点赞间隔时间3秒', duration: 2000, location: 'middle' });
        return false;
    }else{
       timeInterval=(Date.parse(new Date())/1000);
       console.log("点赞时间:"+timeInterval);
       return true;
    }
}

//-----------------------------------------------------------------
/**
 * 查询话题点赞
 * @auhor zlh
 * @param  {[type]} user_id  [description]
 * @param  {[type]} topic_id [description]
 */
function queryTopicPraise(user_id, topic_id) {
    if(pariseTimeInterval()==false){
        return false;
    }
    api.ajax({
        url: config.dev_url + 'praise/is_praised',
        method: 'post',
        data: {
            values: {
                user_id: user_id,
                topic_id: topic_id,
            }
        }
    }, function(ret, err) {
        if (ret) {
            var topic_user_id = $api.getStorage('topic_user_id');
            var topic_ID = $api.getStorage('topic_id');
            var laud = $api.dom('.aui-icon-laud');
            var laud_id = $api.byId('laud-id-'+topic_id);
            var aui_iconfont = $api.dom('.aui-iconfont');

            if (topic_user_id == user_id && topic_ID == topic_id || laud_id.className == 'aui-iconfont aui-icon-laud praise-color') {
                api.toast({ msg: '你已经赞过了', duration: 2000, location: 'middle' });

            } else {
                if (laud_id.className == 'aui-iconfont aui-icon-laud') {
                    praiseTopic(user_id, topic_id);
                }
            }
        }
    });
}

//-----------------------------------------------------------------
/**
 * 查询评论点赞
 * @auhor zlh
 * @param user_id
 * @param comment_id
 */
function queryCommentPraise(user_id, comment_id) {
    if(pariseTimeInterval()==false){
        return false;
    }
    api.ajax({
        url: config.dev_url + 'praise/is_praised',
        method: 'post',
        data: {
            values: {
                user_id: user_id,
                comment_id: comment_id
            }
        }
    }, function(ret, err) {
        if (ret.is_praised === 1){
              api.toast({ msg: '此评论你已赞过', duration: 2000, location: 'middle' });
        } else {
            praiseComment(user_id, comment_id);
        }
    });
}

//---------------------------------------------------------------
/**
 * 话题点赞执行
 * @auhor zlh
 * @param user_id
 * @param topic_id
 */
function praiseTopic(user_id, topic_id) {
    api.ajax({
        url: config.dev_url + 'praise/create',
        method: 'post',
        data: {
            values: {
                user_id: user_id,
                topic_id: topic_id,
            }
        }
    }, function(ret, err) {
        if (ret) {
            $api.setStorage('topic_user_id', user_id);
            $api.setStorage('topic_id', topic_id);
            getTopicDetails(topic_id);
            //记录点赞时间
            timeInterval=(Date.parse(new Date())/1000);
        }
    });
}

//-----------------------------------------------------------------
/**
 * 评论点赞执行
 * @auhor zlh
 */
function praiseComment(user_id, comment_id) {
    api.ajax({
        url: config.dev_url + 'praise/create',
        method: 'post',
        data: {
            values: {
                user_id: user_id,
                comment_id: comment_id,
            }
        }
    }, function(ret, err) {
        if (ret) {
            $api.setStorage('comment_user_id', user_id);
            $api.setStorage('comment_id', comment_id);
            
        }
    });
}

//-----------------------------------------------------------------
/**
 * 激活输入框
 * 点击激活隐藏的输入框
 */
function onInput() {
    var input = $api.dom('#footer');
    input.style.display = "block";
}

//-------------------------------------------------------------------
/**
 * 更多菜单
 * @auhor zlh
 * description: [微信分享,复制,收藏,举报]
 */
function moreMenu(topic_id, user_id,title,content){
        openMask();
        api.openFrame({
        name: 'moremenu',
        url: './more_menu.html',
        bounces: false,
        rect:{ x: 0, y: 0,
            w: 'auto', h: 'auto'
        },
        pageParam: {
           "topic_id":topic_id,
           "topic_user_id":user_id,
           "topic_title":title,
           "topic_content":content
        }
    });

    //将更多frame置于最前
    api.bringFrameToFront({
        from: 'moremenu'
    });
}

//-----------------------------------------------------------------
/**
 * 点击遮罩层事件
 * @author:hj
 */
function onCoverClick(){
    $api.css($api.dom("#cover"),"display:none");
}

//-------------------------------------------------------------------------
/**
 * 打开遮罩
 * @auhor zlh
 */
function openMask() {
    api.openFrame({
        name: 'mask',
        url: './mask2.html',
        bounces: false,
        rect: {
            x: 0,
            y: 0,
            w: 'auto',
            h: 'auto'
        }
    });
}

//-----------------------------------------------------------------
/**
 * 话题详情中的图片显示
 * @author:hj
 */
function topicDetailPhoto(){
    var topic_temp = doT.template($api.dom('#topic-photo-sql').innerHTML);
    $api.dom('#topic-photo').innerHTML = topic_temp(data);
}

//-----------------------------------------------------------------
/**
 * UIChatBox模块
 * @author:hj
 * 只能在window中用
 */
function inputBox(){
 var UIChatBox = api.require('UIChatBox');    
 UIChatBox.open({
    placeholder: '',
    maxRows: 4,
    emotionPath: 'widget://image/emotion',
        // emotionPath: '../../image/emotion',
        texts: {
            recordBtn: {
                normalTitle: '按住说话',
                activeTitle: '松开结束'
            },
            sendBtn: {
                title: 'send'
            }
        },
        styles: {
            inputBar: {
                borderColor: '#d9d9d9',
                bgColor: '#f2f2f2'
            },
            inputBox: {
                borderColor: '#B3B3B3',
                bgColor: '#FFFFFF'
            },
            emotionBtn: {
                normalImg: 'widget://res/img/chatBox_face1.png'
            },
            extrasBtn: {
                normalImg: 'widget://res/img/chatBox_add1.png'
            },
            keyboardBtn: {
                normalImg: 'widget://res/img/chatBox_key1.png'
            },
            speechBtn: {
                normalImg: 'widget://res/img/chatBox_key1.png'
            },
            recordBtn: {
                normalBg: '#c4c4c4',
                activeBg: '#999999',
                color: '#000',
                size: 14
            },
            indicator: {
                target: 'both',
                color: '#c4c4c4',
                activeColor: '#9e9e9e'
            },
            sendBtn: {
                titleColor: '#4cc518',
                bg: '#999999',
                activeBg: '#46a91e',
                titleSize: 14
            }
        },
        extras: {
            titleSize: 10,
            titleColor: '#a3a3a3',
            btns: [{
                title: '图片',
                normalImg: 'widget://res/img/chatBox_album1.png',
                activeImg: 'widget://res/img/chatBox_album2.png'
            }, {
                title: '拍照',
                normalImg: 'widget://res/img/chatBox_cam1.png',
                activeImg: 'widget://res/img/chatBox_cam2.png'
            }]
        }
    }, function(ret, err) {
        if (ret) {
            //alert(JSON.stringify(ret));
        } else {
            //alert(JSON.stringify(err));
        }
    }); 
}

//---------------------------------------------------------------------
/**
 * 打开图片浏览
 * @auhor fyy
 */
function openPictureBrower() {
    var imageBrowser = api.require('imageBrowser');
    imageBrowser.openImages({
        imageUrls : [
        'http://apicloud.com/img/modulestore/jizhiyun.png',
        'http://apicloud.com/img/modulestore/banner-gaode.png']
    });
}