apiready = function() {
    //状态栏颜色
    api.setStatusBarStyle({
        style: 'light'
    });

    //退出app
    //exitApp();

    //底部tab函数
    switchTabs(1);

    //检测是否有话题发布成功操作,弹出提示
    onSendtopicFinished();

    //遮罩函数
    mask();

    //判断用户是否存在，不存在创建在登陆
    isUserExists();

    //返回顶部并更新
    $api.addEvt($api.byId('back-to-top'),'click',function() {
        backToTop();
    });
}

//自定义变量
var mask = isShowMask();
var index = null;
var header = $api.byId('header');
var main = $api.byId('main');
var footer = $api.byId('footer');
var headerPos = $api.offset(header);
var mainPos = $api.offset(main);
var footerPos = $api.offset(footer);


//---------------------------------------------------------------------
/**
 * 首页tab切换
 * @auhor zlh
 */
var footerTabs = new auiTab({
    element: document.getElementById("footer")
}, function(ret) {
    if (ret) {
        if (ret.index == 1) {
            header.className = "home";
            switchTabs(ret.index);
        }
        else if (ret.index == 2) {
            header.className = "rank";
            switchTabs(ret.index);
        }
        else if (ret.index == 3) {
            header.className = "my";
			api.closeFrame({name:'my'});
            switchTabs(ret.index);
        }
    }
});

//--------------------------------------------------------------------
/**
 * 排行tab切换
 * @auhor zlh
 */
var rankTabs = new auiTab({
    element: document.getElementById("rank")
}, function(ret) {
    if (ret) {
        index = ret.index - 1;
        api.setFrameGroupIndex({
            name: 'rank',
            index: index,
            hidden: false
        });
    }
});

//----------------------------------------------------------------------
/**
 * 隐藏所有子级窗口
 * @auhor zlh
 */
function hideFrames() {
    api.setFrameAttr({
        name: 'home',
        hidden: true
    });
    api.setFrameAttr({
        name: 'my',
        hidden: true
    });
    api.setFrameGroupAttr({
        name: 'rank',
        hidden: true
    });
}


//-----------------------------------------------------------------------
/**
 * 按钮切换
 * @auhor zlh
 * @param active [根据参数active来判断要加载的页面]
 */

function switchTabs(active) {
    hideFrames();
    if (active == 2) {
        api.sendEvent({
            name: 'showSubIndexFrame'
        });
    }
    switch (active) {
        // 1打开首页
        case 1:
            api.openFrame({
                name: 'home',
                url: './home/home.html',
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                bounces: false,
                reload: true,
                rect: {
                    x: 0,
                    y: headerPos.h,
                    w: 'auto',
                    h: mainPos.h
                }
            });
            break;
        // 2打开排行榜tab页面
        case 2:
            api.openFrame({
                name: 'rank',
                url: './rank/rank.html',
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                bounces: false,
                reload: true,
                rect: {
                    x: 0,
                    y: headerPos.h,
                    w: 'auto',
                    h: mainPos.h
                }
            });
            break;
        // 3打开个人中心
        case 3:
            api.openFrame({
                name: 'my',
                url: './my/my.html',
                bounces: false,
                bgColor: "#fff",
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: mainPos.h
                }
            });
            break;
    }
}

//-------------------------------------------------------------------------
/**
 * 打开遮罩
 * @auhor zlh
 */
function openMask() {
    setTimeout(function() {
        api.openFrame({
            name: 'mask',
            url: './home/mask.html',
            bounces: false,
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            }
        });
    }, 100);
}


//----------------------------------------------------------------------
/**
 * 判断遮罩是否执行
 */
function isShowMask() {
    if (!$api.getStorage('showMask')) {
        openMask();
    }
    return function() {
        var showMask = $api.setStorage('showMask', 'mask');
        return showMask;
    };
}


//-----------------------------------------------------------------------
/**
 * 跳转发布话题
 * @auhor zlh
 */
function openSendTopic() {
    api.openWin({
        name: 'send_topic',
        url: './home/new_topic.html',
        bounces: false,
        showProgress: true,
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        slidBackEnabled: false,
        delay: 300,
        allowEdit: true,
        animation: {
            duration: 300
        }
    });
}


//---------------------------------------------------------------------------
/**
 * 话题发布成功函数
 * @author:hj
 */
function onSendtopicFinished(){
    var param = api.pageParam;
    // alert(JSON.stringify(param));
    if (param.topic == "release") {
        api.toast({ msg: '话题发布成功。', duration: 2000, location: 'middle' });
        api.closeWin();
        //获取最新的10条评论数据
        //getTopicDatas(10);
    }
}





//------------------------------------------------------------------------
/**
 * 返回顶部并更新
 * @auhor fyy
 */
function backToTop(){
    api.openFrame({
        name: 'home',
        url: './home/home.html',
        vScrollBarEnabled: false,
        hScrollBarEnabled: false,
        bounces: false,
        reload:true,
        rect: {
             x: 0,
             y: headerPos.h,
             w: 'auto',
             h: mainPos.h
         }
     });
}