//记录已加载的一级评论,后面在来判断有没有点过赞
var commentIdList={};

/**
 * 获取发送评论所需要的参数
 * @author:hj
*/
function saveCommentParam(level) {
    var comment = $api.val($api.dom("#comment-input"));
    var time=(Date.parse(new Date())/1000);
    var timeInterval=localStorage.getItem("commentTimeInterval");
    if (comment.length === 0) {
        api.toast({ msg: '评论内容不能为空', duration: 2000, location: 'middle' });
        return false;
    }else if((time-timeInterval)<10) {
        api.toast({ msg: '发布评论有10秒时间间隔', duration: 2000, location: 'middle' });
        //console.log("时间"+timeInterval+" "+time);
        return false;
    }
    var data = {};
    data.topic_id = api.pageParam.topic_id; //这前面不加var
    data.topic_user_id = localStorage.getItem("comment-topic-userid");
    data.user_id = localStorage.getItem("user-id");

    data.headimg = localStorage.getItem("user-headimg");
    data.nickname = localStorage.getItem("user-nickname");
    data.content = $api.val($api.dom("#comment-input"));
    //判断是一级评论还是二级评论
    data.level = localStorage.getItem("comment-level");
    if (data.level == 2) {
        data.parent_id = localStorage.getItem("comment-parentId");
    }
    return data;
}

//-----------------------------------------------------------------
/**
 * 执行发送评论
 * @author:hj
*/
function saveComment() {
    var data = saveCommentParam();
    if (data == false) {
        return false;
    }
    if (limitCommentContentLength() == false) {
        return false;
    }
    api.ajax({
        url: config.dev_url + 'comment/create',
        method: 'post',
        data: {
            values: data
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.status == 0) {
            api.toast({ msg: '评论成功', duration: 2000, location: 'middle' });
            $api.dom('#footer').style.display = "none";
            localStorage.setItem("commentTimeInterval",(Date.parse(new Date())/1000));
            createBrowseHistory(ret.data.user_id, ret.data.topic_id);
            getComment();
        } else {
            api.toast({ msg: '评论失败', duration: 2000, location: 'middle' });
        }
        localStorage.setItem("comment-level", "1");
        $api.attr($api.dom("#comment-input"), 'placeholder', "评论");
    });
}

//-----------------------------------------------------------------
/**
  追加评论数据todo
  author:hj
*/
function addtoComment() {
    if (ret.status == 0 && ret.data.length > 0) {
        $api.css($api.dom('#comment-null'), "display:none;")
        for (var i = 0; i < ret.data.length; i++) {
            var tmpl = $api.dom('#j-tmpl').innerHTML;
            //定义dot函数,将dot模板代码作为参数传进去
            var doTtmpl = doT.template(tmpl);
            //将要处理的数据传入上方定义的dot函数
            $api.append($api.dom('#comment_list'), doTtmpl(ret.data[i]));
            //$api.dom('#comment_list').innerHTML=doTtmpl(ret.data[i]);
        }
    }
}

//-----------------------------------------------------------------
/**
  获取评论数据
  author:hj
*/
function getComment() {
    api.ajax({
        url: config.dev_url + 'comment/recent_list',
        method: 'post',
        data: {
            values: {
                "topic_id": api.pageParam.topic_id,
                "num": 10
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.status == 0 && ret.data.length > 0) {
            updateComment(ret);
        }
    });
}

//-----------------------------------------------------------------
/**
 * 异步检测当前用户是否点赞某一评论，并更新点赞按钮状态 old
 * @author:hj
 */
function checkPraise(comment_id) {
    var user_id = localStorage.getItem('user-id');
    api.ajax({
        url: config.dev_url + 'praise/is_praised',
        method: 'post',
        data: {
            values: {
                user_id: user_id,
                comment_id: comment_id,

            },
        }
    }, function(ret, err) {
        if (ret.is_praised === 1) {
            // console.log(ret.is_praised);
            var laud = $api.byId('laud-comment-id-' + comment_id);
            $api.addCls(laud, 'praise-color');
        }
    });
}

//-----------------------------------------------------------------
/**
 * 将获取的评论数据传入html中
 */
function updateComment(ret) {
    if (ret.status == 0 && ret.data.length > 0) {
        var comment = "", comment2 = {};
        var html = '';
        var curr_user_id = localStorage.getItem("user-id");
        for (var i = 0; i < ret.data.length; i++) {
            var time = $z.postTime(ret.data[i].create_timestamp);
            if (time != "") {
                ret.data[i].createdAt = time;
            }
            if (ret.data[i].level == 1) {
                ret.data[i].headimg = user_config[ret.data[i].headimg].avatar;
                var tmpl = $api.dom('#comment-list-data').innerHTML;
                var doTtmpl = doT.template(tmpl);
                comment += doTtmpl(ret.data[i]);
                getSecondComment(api.pageParam.topic_id, ret.data[i].id);
                //异步问题
                commentIdList[ret.data[i].id]=ret.data[i].id;
            }
        }
        $api.html($api.dom('#comment_list'), comment);
        for(var v in commentIdList){
            //每加载一条一级评论判断一次是否被点赞
            console.log(localStorage.getItem("user-id")+" "+commentIdList[v]);
            queryIsPraised(localStorage.getItem("user-id"),commentIdList[v]);
        }
        var html = $api.html($api.dom('#detail-comment-num'));
        $api.html($api.dom('#detail-comment-num'), (parseInt(html) + 1));
        $api.val($api.dom("#comment-input"), "");
    }
}

//-------------------------------------------------------------------
/**
 * 获取指定一级评论的二级评论,传话题id和评论id
 * @param  {[type]} topic_id [description]
 *
 */
function getSecondComment(topic_id, id) {
    api.ajax({
        url: config.dev_url + 'comment/next_level_list',
        method: 'post',
        data: {
            values: {
                topic_id: topic_id,
                id: id
            }
        }
    }, function(ret, err) {
        if (ret) {
            var html = '',
                dataLen = 0;
            var reply_sum = $api.dom('#reply-sum' + id);
            var reply_box = $api.dom('#reply-box' + id);
            if (ret.data.length != 0) {
                dataLen = ret.data.length;
                reply_sum.innerHTML = "共" + dataLen + "条回复";
                reply_box.style.display = "block";
            }
        } else {
            api.alert({ msg: JSON.stringify(err) });
        }
    });
}

//-------------------------------------------------------------------
/**
 * 二级回复显示隐藏
 * @author: ?
 * @param  {[type]} topic_id [description]
 * @param  {[type]} id       [description]
 */
function showSecondReply(topic_id, id) {
    var html = '';
    var icon = $api.dom('#aui-icon' + id);
    var top = $api.dom('.aui-icon-top');
    var down = $api.dom('.aui-icon-down');
    var second_comment = $api.dom('.second-comment' + id);
    var nickname_id = $api.attr($api.dom("#comment-" + id), 'data');
    var iconTD = $api.attr(icon, 'class');
    var create_timestamp = $api.getStorage('create_timestamp');
    if (iconTD == "aui-iconfont aui-icon-top") {
        $api.toggleCls(icon, 'aui-icon-down');
        api.ajax({
            url: config.dev_url + 'comment/next_level_list',
            method: 'post',
            data: {
                values: {
                    topic_id: topic_id,
                    id: id
                }
            }
        }, function(ret, err) {
            if (ret) {
                $api.setStorage('create_timestamp', ret.data.create_timestamp);
                for (var i = 0; i < ret.data.length; i++) {
                    var time = $z.postTime(ret.data[i].create_timestamp);
                    if (time != "") {
                        ret.data[i].createdAt = time;
                    }
                    var tmpl = $api.dom('#comment-list-data2').innerHTML;
                    var doTtmpl = doT.template(tmpl);
                    html += doTtmpl(ret.data[i]);
                }
                $api.html($api.dom("#comment2-" + id), html);
            } else {
                api.alert({ msg: JSON.stringify(err) });
            }
        });
    } else {
        $api.removeCls(icon, 'aui-icon-down');
        $api.html($api.dom("#comment2-" + id), html);
    }
}

//-------------------------------------------------------------------
/**
 * 点击一级评论内容激活二级评论发送窗口
 * @author:hj
 */
function onCommentClicked(id){
    $api.dom('#footer').style.display = "block";
    var nickname = $api.attr($api.dom("#comment-" + id), 'data');
    localStorage.setItem("comment-level", 2);
    localStorage.setItem("comment-parentId", id);
    $api.attr($api.dom("#comment-input"), 'placeholder', "回复@" + nickname + "  ");
    $api.css($api.dom("#footer"),"display:block;");
    $api.dom("#comment-input").focus();
}

//-----------------------------------------------------------------
/**
 * 点击话题评论将默认隐藏的评论框显示出
 * @author:hj
 */
function onCommentShow(){
    $api.dom('#footer').style.display = "block";
    $api.dom("#comment-input").focus();
}

//-----------------------------------------------------------------
/**
 * 发布评论的字数控制
 * @author:hj
 */
function limitCommentContentLength(){
    var content = $api.val($api.dom('#comment-input'));
    var len = convertStrLen(content);
    if (len > 150) {
        api.toast({ msg: '您输入的字已经超过150个字了！', duration: 2000, location: 'middle' });
        return false;
        // $api.val($api.dom("#topic-content-input"), content.substr(0, comment_length));
        // $api.html($api.dom('#topic-content-num'), 150 + '/150');
        // localStorage.setItem("user-topic-content", content);
    } else {
        return true;
        // content_length = content.length;
        // $api.html($api.dom('#topic-content-num'), len + '/150');
    }
}