//-----------------------------------------------------------------
/**
 * 登陆后打开首页文件
 */
function openIndex(userid) {
    api.openFrame({
        name: 'index',
        url: 'html/index.html',//home/frm_topic_details.html
        rect: {
            x: 0,
            y: 0,
            w: 0,
            h: 0
        }
    });



    var ajpush = api.require('ajpush');

    ajpush.init(function(ret) {
        if (ret && ret.status) {
            //success
        }
    });



    var param = {
        alias: userid,
        tags: ['tag2', 'tag2']
    };
    ajpush.bindAliasAndTags(param, function(ret) {
        var statusCode = ret.statusCode;
    });

    ajpush.setListener(
        function(ret) {
            var id = ret.id;
            var title = ret.title;
            var content = ret.content;
            var extra = ret.extra;
            var param = {
                id: -1
            };
            ajpush.clearNotification(param, function(ret) {
                if (ret && ret.status) {
                    //success
                }
            });
        }
    );
}

//-------------------------------------------------------------------
/**
 * 判断微信是否安装
 * @author:hj
 */
function wxIs() {
    var wx = api.require('wx');
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            return true;
        } else {
            return false;
        }
    });
}

//----------------------------------------------------------------
/**
 * 判断用户是否已登陆,页面加载时运行,用户点微信登陆按钮也要执行一遍
 * @author:hj
 */
function loginWxIs() {
    if (localStorage.getItem("user-accessToken")) {
        var userid = localStorage.getItem("user-id");
        openIndex(userid);
        return true; // 点登陆按钮时已登陆用
    }
}

//-----------------------------------------------------------------
/**
 * 微信登陆成功后设置用户信息
 * @author:hj
 */
function setUserinfo(ret) {
    localStorage.setItem("user-openid", ret.openid);
    localStorage.setItem("user-headimgurl", ret.headimgurl);
    isUserExists();
}

//------------------------------------------------------------------
/**
 * 设置用户信息
 * @author:hj
 */
function getUserinfo(ret) {
    var wx = api.require('wx');
    localStorage.setItem("user-dynamicToken", ret.dynamicToken);
    localStorage.setItem("user-accessToken", ret.accessToken);
    wx.getUserInfo({
        accessToken: ret.accessToken,
        openId: ret.openId
    }, function (ret, err) {
        if (ret.status) {
            setUserinfo(ret);
        } else {
            alert(err.code);
        }
    });
    /*微信返回数据={ status:true, sex:1(性别:1为男2为女)
     nickname:"微信用户昵称",
     unionid:"同一微信用户平台账号的用户唯一标识",
     privilege:[](用户特权信息数组),
     province:"Guizhou"(用户所在地),
     headimgurl:"http://……"，
     country:"CN","city":"SouthwestGuizhou",
     openid:"",(这是微信返回的是小写),"code":0
     }
     */
}

//--------------------------------------------------------------------
/**
 * 登陆成功后执行获取用户的token,在通过token来获取设置用户信息
 * @author：hj
 */
function loginWxToken(ret) {
    var wx = api.require('wx');
    wx.getToken({
        apiKey: 'wxda2150cba02f44e4',
        apiSecret: "9a77174397146d6aafab456b66b13710",
        code: ret.code
    }, function (ret, err) {
        if (ret.status) {
            getUserinfo(ret);

        }
    });
}

//--------------------------------------------------------------------
/**
 * 处理微信登陆后微信返回的参数
 * @author:hj
 */
function loginWxParamHandle(ret, err) {
    var wx = api.require('wx');
    if (err.code == "1") {
        alert("用户取消登陆");
        return false;
    }
    if (ret.status) {
        loginWxToken(ret);
    }
}

//---------------------------------------------------------------------
/**
 * 登陆微信
 * @author:hj
 */
function loginWx() {
    var wx = api.require('wx');
    if (wxIs() == false) {
        alert('当前设备未安装微信客户端');
        return false;
    }
    if (loginWxIs()) {
        return false;//
    }
    wx.auth({
        //这个值
        apiKey: 'wxda2150cba02f44e4'
    }, function (ret, err) {
        loginWxParamHandle(ret, err);
    });
}

//---------------------------------------------------------------------
/**
 * 定义随机参数
 * @author:hj
 * 没有做微信登陆直接就到index_wrap页面中去时指定测试用户,确保此函数在微信登陆前执行
 */
function defineRandomParam() { //userRandom
    /*
     *	modify: 华仔
     *	注释了getItem("user-accessToken"))getItem("user-accessToken"))
     */
    /*if (localStorage.getItem("user-accessToken")) {
     return false;
     }
     if (localStorage.getItem("user-accessToken")) {
     return false;
     }*/
    //取得随机用户名编号1-50和随机用户前缀编号1-50
    var userId = $z.randByTime(user_config.length);
    var descId = $z.randByArray(desc_config.length);
    /*放弃10个随机,要从150个随机中
     var userIdArray = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
     var userId = userIdArray.sort(function() {
     return 0.5 - Math.random();
     });
     */
    $z.setUserInfo(userId, descId);
    var userRandom = JSON.parse(localStorage.getItem("user-random"));
    localStorage.setItem("user-nickname", userRandom.nickname);
    //这个服务器要求只能是数字
    // localStorage.setItem("user-headimg", userId);

    //localStorage.setItem("user-openid", "openid" + userId);
    //保存30天的这个dynamicToken在服务器上时又名refresh_token
    //localStorage.setItem("user-dynamicToken", "Token" + userId);
    localStorage.setItem("user-id", userId);

    /* */
}
function loginUid(uid) {
    api.ajax({
        url: config.dev_url + 'user/login_uid',
        method: 'post',
        data: {
            values: {
                "id": uid
            }
        },
        dataType: 'json'
    }, function (ret, err) {
        if (ret.status == 0) {
            //alert("登录成功" + ret.data.id);
            localStorage.setItem("user-id", ret.data.id);
            localStorage.setItem("user-nickname", ret.data.nickname);
            localStorage.setItem("user-headimg", ret.data.headimg);
            console.log("登陆后得用户uid:" + ret.data.id);
            openIndex(ret.data.id);
        } else {
            //console.log("登陆失败 " + openId + " " + refreshToken);
            api.toast({msg: '登陆失败,请重点登陆按钮', duration: 2000, location: 'middle'});
            api.closeToWin({name: 'root'});
        }
    });
    /*ret={{"updatedAt":"2016-11-19T08", //更新时间
     "id":584,"nickname":"%E5%A4%",
     "createdAt":"2016-11-19T0", //创建时间
     "headimg":46,"weixin_open_id":"testOpenid46",
     "weixin_refresh_token":"testRefreshToken36",
     "energy":100},"status":0}
     */
}

function loginTest() {
    // var alarmNotification = api.require('alarmNotification');
    // alarmNotification.setAlarm({
    //     isLed: true,
    //     title: '标题',
    //     content: '内容',
    //     tickerText:'通知栏提示文字',
    //     interval:100
    // }, function (ret, err) {
    //     if (ret) {
    //         alert(JSON.stringify(ret));
    //     } else {
    //         alert(JSON.stringify(err));
    //     }
    // });
    var openidtest = $api.dom("#openidtest");
    //console.log("186f: " + openidtest.value);
    if (openidtest.value) {

        //var user = {headimgurl: 2, openid: openidtest.value};
        //console.log("190f: " + user.openid);
        //setUserinfo(user);
        loginUid(openidtest.value);

    }
}