//------------------------------------------------------------------------
/**
 * 判断用户登录状态
 * @author:hj
 */
function isUserExists() {
    var openId = localStorage.getItem("user-openid");
    var refreshToken = localStorage.getItem("user-dynamicToken");
    api.ajax({
        url: config.dev_url + 'user/is_exists',
        method: 'post',
        data: {
            values: {
                "weixin_open_id": openId,
                "weixin_refresh_token": refreshToken,
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.is_exists == 1) {
            console.log("用户存在" + JSON.stringify(ret));
            loginUser();
        } else {
            console.log("用户不存在,创建,在登陆" + JSON.stringify(ret) + " " + openId + " " + refreshToken);
            createUser();
        }
    });
}

//-----------------------------------------------------------------
/**
 * 创建用户
 * @author:hj
*/
function createUser() {
    var openId = localStorage.getItem("user-openid");
    var refreshToken = localStorage.getItem("user-dynamicToken");
    var nickname = localStorage.getItem("user-nickname");
    var headimg = localStorage.getItem("user-headimg");
    console.log(openId + " " + refreshToken + " " + " " + headimg);
    api.ajax({
        url: config.dev_url + 'user/create',
        method: 'post',
        data: {
            values: {
                "weixin_open_id": openId,
                "nickname": nickname,
                "headimg": headimg,
                "energy": 100
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.status == 0) {
            loginUser();
        }
    });
}

//-----------------------------------------------------------------
/**
 * 用户登陆
 * @author:hj
*/
function loginUser() {
    var openId = localStorage.getItem("user-openid");
    var refreshToken = localStorage.getItem("user-dynamicToken");
    api.ajax({
        url: config.dev_url + 'user/login',
        method: 'post',
        data: {
            values: {
                "weixin_open_id": openId
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.status == 0) {
            localStorage.setItem("user-id", ret.data.id);
            localStorage.setItem("user-nickname", ret.data.nickname);
            localStorage.setItem("user-headimg", ret.data.headimg);
            var userid = localStorage.getItem("user-id");
            openIndex(userid);
            console.log("登陆后得用户id:" + ret.data.id);
        } else {
            console.log("登陆失败 " + openId + " " + refreshToken);
            api.toast({ msg: '登陆失败,请重点登陆按钮', duration: 2000, location: 'middle' });
            api.closeToWin({ name: 'root' });
        }
    });
    /*ret={{"updatedAt":"2016-11-19T08", //更新时间
        "id":584,"nickname":"%E5%A4%",
        "createdAt":"2016-11-19T0", //创建时间
        "headimg":46,"weixin_open_id":"testOpenid46",
        "weixin_refresh_token":"testRefreshToken36",
        "energy":100},"status":0}
    */
}
