/*
* @Author: zlh
* @Date:   2017-01-18 15:11:06
*/


//------------------------------------------------------------------------
/**
 * 微信登录
 * @author: zlh
 * 自定义缓存变量: clicktag
 */
$api.setStorage('clicktag', true);
function loginWx() {
	if(!document.getElementById('protocol_checked').checked){
        api.toast({ msg: '勾选用户协议，才能登陆哦！', duration: 2000, location: 'middle' });
		return ;
	}
    var wx = api.require('wx');
    var clicktag = $api.getStorage('clicktag');
    if (clicktag === 'true') {
        $api.setStorage('clicktag', false);
        wx.isInstalled(function(ret, err) {
        if (ret.installed) {
            wx.auth({
                apiKey: 'wxda2150cba02f44e4'
            }, function(ret1, err1) {
                if (err1.code == "1") {
                    clicktag = true;
                    api.toast({
                        msg: '已取消登录',
                        duration: 2000,
                        location: 'middle'
                    });
                }
                if (ret1.status) {
                    api.showProgress({
                        style: 'default',
                        animationType: 'fade',
                        title: '登录中...',
                        text: '请稍后...',
                        modal: true
                    });

                    // alert(JSON.stringify(ret1));
                    wx.getToken({
                        apiKey: 'wxda2150cba02f44e4',
                        apiSecret: "9a77174397146d6aafab456b66b13710",
                        code: ret1.code
                    }, function(ret2, err2) {
                        if (ret2.status) {
                            // alert(JSON.stringify(ret2));
                            localStorage.setItem("user-accessToken", ret2.accessToken);
                            localStorage.setItem("user-dynamicToken", ret2.dynamicToken);
                            wx.getUserInfo({
                                accessToken: ret2.accessToken,
                                openId: ret2.openId
                            }, function(ret3, err3) {
                                if (ret3.status) {
                                    localStorage.setItem("user-openid", ret3.openid);
                                    $api.setStorage('wx_login_openid', ret3.openid);
                                    isUserExists();

                                }
                            });
                        }
                    });
                }
            });
        } else {
            if (api.systemType == 'android') {
                alert('当前设备未安装微信客户端');
            }
        }
        });
    } else {
        return false;
    }

    setTimeout(function() { clicktag = true }, 15000);
}


//------------------------------------------------------------------------
/**
 * 判断用户登录状态
 * @author:hj
 */
function isUserExists() {
    var openId = localStorage.getItem("user-openid");
    var refreshToken = localStorage.getItem("user-dynamicToken");
    api.ajax({
        url: config.dev_url + 'user/is_exists',
        method: 'post',
        data: {
            values: {
                "weixin_open_id": openId,
                "weixin_refresh_token": refreshToken,
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.is_exists == 1) {
            // alert("用户存在" + JSON.stringify(ret));
            loginUser();
        } else {
            // alert("用户不存在,创建,在登陆" + JSON.stringify(ret) + " " + openId + " " + refreshToken);
            createUser();
        }
    });
}


//-----------------------------------------------------------------
/**
 * 创建用户
 * @author: zlh
*/
function createUser() {

    // 注册第一次登录的用户信息,随机设置
    var userId = $z.randByTime(user_config.length);
    var descId = $z.randByArray(desc_config.length);
    $z.setUserInfo(userId, descId);
    var userRandom = JSON.parse(localStorage.getItem("user-random"));
    localStorage.setItem("user-nickname", userRandom.nickname);
    localStorage.setItem("user-headimg", userRandom.avatar);

    // 设置好的用户信息,发送ajax保存到数据库
    var openId = localStorage.getItem("user-openid");
    var nickname = localStorage.getItem("user-nickname");
    var headimgStr = localStorage.getItem("user-headimg");
    var headimg = headimgStr.replace(/[^0-9]/ig,"");
    api.ajax({
        url: config.dev_url + 'user/create',
        method: 'post',
        data: {
            values: {
                "weixin_open_id": openId,
                "nickname": nickname,
                "headimg": headimg,
                "energy": 100
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.status == 0) {
            loginUser();
        }
    });
}


//-----------------------------------------------------------------
/**
 * 用户登陆
 * @author:hj
*/
function loginUser() {
    var openId = localStorage.getItem("user-openid");
    var refreshToken = localStorage.getItem("user-dynamicToken");
    api.ajax({
        url: config.dev_url + 'user/login',
        method: 'post',
        data: {
            values: {
                "weixin_open_id": openId
            }
        },
        dataType: 'json'
    }, function(ret, err) {
        if (ret.status == 0) {
            localStorage.setItem("user-id", ret.data.id);
            localStorage.setItem("user-nickname", ret.data.nickname);
            localStorage.setItem("user-headimg", ret.data.headimg);
            var userid = localStorage.getItem('user-id');
            openIndex(userid);
            // alert("登录成功, 登陆后得用户id:" + ret.data.id);
        } else {
            api.toast({ msg: '登陆失败,请重点登陆按钮', duration: 2000, location: 'middle' });
            api.closeToWin({ name: 'login' });
        }
    });

    // 获取的数据,作参考
    /*ret={{"updatedAt":"2016-11-19T08", //更新时间
        "id":584,"nickname":"%E5%A4%",
        "createdAt":"2016-11-19T0", //创建时间
        "headimg":46,"weixin_open_id":"testOpenid46",
        "weixin_refresh_token":"testRefreshToken36",
        "energy":100},"status":0}
    */
}


//-----------------------------------------------------------------
/**
 * 打开首页
 * @author:zlh
 */
function openIndex(userid) {
        // 关闭登录等待框
        api.hideProgress();

        // 登录成功打开首页
        api.openDrawerLayout({
            reload:true,
            slidBackEnabled:false,
            name: 'win_indexSlider',
            url: './win_indexSlider.html',
            leftPane: {
                name: 'win_indexSlider',
                url: './win_indeFixed.html',
                edge: api.winWidth / 4,
                bounces:false,
                bgColor:'#FD3C50'
            },
            bounces:false,
            animation: {
                type:"huch",
                subType:"from_right",
                duration: 300
            }
        });

        // 设置登陆按钮的状态(成功登陆点击按钮才生效)
        $api.setStorage('clicktag', true);

        // 登录成功提示
        api.toast({
            msg: '登录成功',
            duration: 2000,
            location: 'middle'
        });


        // 极光推送初始化
        var ajpush = api.require('ajpush');

        ajpush.init(function(ret) {
            if (ret && ret.status) {
                //success
            }
        });

        var param = {
            alias: userid,
            tags: ['tag2', 'tag2']
        };
        ajpush.bindAliasAndTags(param, function(ret) {
            var statusCode = ret.statusCode;
        });
        // 监听极光推送消息
        ajpush.setListener(
            function(ret) {
                var id = ret.id;
                var title = ret.title;
                var content = ret.content;
                var extra = ret.extra;
                var param = {
                    id: -1
                };
                if ($api.getStorage('message_sound') === 'true') {
                    api.notification({
                        sound: 'default'
                    }, function(ret, err) {
                        var id = ret.id;
                    });
                }
                if ($api.getStorage('message_shake') === 'true') {
                    api.notification({
                        vibrate: [1000, 1000]
                    }, function(ret, err) {
                        var id = ret.id;
                    });
                }

                ajpush.clearNotification(param, function(ret) {
                    if (ret && ret.status) {
                        //success
                    }
                });
            }
        );
}
