/**
 * 成就卡片翻转
 */
function funBackOrFront(obj) {
    var objChildren = obj.children;
    for (var i = 0; i < objChildren.length; i++) {
        if ($api.hasCls(objChildren[i], 'out')) {
            $api.addCls(objChildren[i], 'in');
            $api.removeCls(objChildren[i], 'out');
        } else {
            $api.addCls(objChildren[i], 'out');
            $api.removeCls(objChildren[i], 'in');
        }
    }
}


// ----------------------------------------------------------------------------------------
/**
 *
 * 获取老司机成就
 * (成就: 后端根据用户完成的成就任务给出完成进度,是否完成
    请求:
        id:用户id,
        achievement_id: 成就id,
        title: 成就名称,
        classify: 分类,
        content: 成就条件
        reward: 成就奖励点数
    返回:
        当前进度
    )
 */
function getAchievement(id, classify) {
    var count = null,
        sum = null,
        percent = null;
    var user_id = localStorage.getItem('user-id');
    api.ajax({
        url: config.dev_url + 'reward/find_progress',
        method: 'post',
        data: {
            values: {
                user_id: user_id
            }
        }
    }, function(ret, err) {
        if (ret.status == 0) {
            var img = $api.domAll(id + ' .achievement-img');
            var title = $api.domAll(id + ' .aui-title');
            var content = $api.domAll(id + ' .aui-card-list-content-padded');
            var reward = $api.domAll(id + ' .aui-card-list-footer');
            var progress_detail = $api.domAll(id + ' .progress-detail');
            var progress = $api.domAll(id + ' .progress-value');
            var progress_bar = $api.domAll(id + ' .progress-bar');
            for (var i = 0, j=0; i < achievement_config.length; i++) {
                if (achievement_config[i].classify == classify) {
                    count = ret.data[achievement_config[i].data_id];
                    sum = achievement_config[i].number;
                    img[j].src = "../../image/achievement/" + achievement_config[i].img;
                    title[j].innerHTML = achievement_config[i].title;
                    content[j].innerHTML = achievement_config[i].content;
                    reward[j].innerHTML = "获得奖励: 成就点数+" + achievement_config[i].reward;
                    progress_detail[j].innerHTML = ret.data[achievement_config[i].data_id] + '/' + achievement_config[i].number;
                    percent = (parseInt((count / sum) * 100) > 100) ? 100 : parseInt((count / sum) * 100);
                    progress[j].innerHTML = percent + "%";
                    if (percent > 10) {
                        progress[j].style.right = 0;
                    }
                    progress_bar[j].style.width = percent + "%";
                    j++;
                }
            }
        } else {
            api.alert({
                msg: JSON.stringify(err)
            });
        }
    });
}