/*
 * @Author: zlh
 * @Date:   2016-12-08 15:09:10
 * @Last Modified by:   Marte
 * @Last Modified time: 2017-01-24 16:54:58
 */
apiready = function() {
    api.parseTapmode();

    //tab默认加载
    messageTabs(0);
    newMessageNum(1);
    newMessageNum(2);
}


// ----------------------------------------------------------------------------------------
//自定义变量
var header = $api.byId('header');
var main = $api.byId('main');
var headerPos = $api.offset(header);
var mainPos = $api.offset(main);


// ----------------------------------------------------------------------------------------
/**
 * 使用AUI tab栏功能
 * 实例化对象
 */
var Tab = new auiTab({
    element: document.getElementById("message-tab"),
}, function(ret) {
    if (ret) {
        var index = ret.index - 1;
        api.setFrameGroupIndex({
            name: 'messages',
            index: index,
            scroll: true
        });
        messageTabs(index);
    }
});


// ----------------------------------------------------------------------------------------
/**
 * tab切换
 * @param index
 * 根据索引切换页面
 */
function messageTabs(index) {
    var count = null,
        current = null,
        commentNum = null,
        praiseNum = null,
        noticeNum = null;
    var ret_index = 0;
    api.openFrameGroup({
        name: 'messages',
        background: '#fff',
        scrollEnabled: false,
        rect: {
            x: 0,
            y: headerPos.h,
            w: 'auto',
            h: mainPos.h
        },
        index: index,
        frames: [{
            name: 'message_comment',
            url: 'message_comment.html',
        }, {
            name: 'message_praise',
            url: 'message_praise.html',
        }, {
            name: 'message_notice',
            url: 'message_notice.html',
        }]
    }, function(ret, err) {
		$api.setStorage('current',$api.getStorage('index'));
        current = $api.getStorage('current');
        // alert($api.getStorage('current'));
        // alert($api.dom(current).innerHTML);

        if ($api.getStorage('current') == '.badge-comment') {
            $api.setStorage('comment_count', $api.getStorage('commentMessageNum'));
            $api.dom(current).style.display = 'none';
        } else if($api.getStorage('current') == '.badge-praise') {
            $api.setStorage('praise_count',  $api.getStorage('praiseMessageNum'));
            $api.dom(current).style.display = 'none';
        }

        if(ret.index == 0) {
        	$api.setStorage('index','.badge-comment');
        } else if(ret.index == 1) {
        	$api.setStorage('index','.badge-praise');
            ret_index = ret.index + 1;
        } else if(ret.index == 2) {
       		$api.setStorage('index','.badge-notice');
            ret_index = ret.index + 1;
        }
    });
}


// ----------------------------------------------------------------------------------------
/**
 * 清空功能
 * @param index
 * 根据索引清空相应页面数据 [评论,赞,通知]
 */
function removeMessage() {
    var active = $api.dom('.aui-active');
    var activeIndex = $api.attr(active, 'data-item-order');
    if (activeIndex == 0) {
        api.execScript({
            frameName: 'message_comment',
            script: 'removeComment()'
        });
    }
    else if(activeIndex == 1) {
        api.execScript({
            frameName: 'message_praise',
            script: 'removePraise()'
        });
    }
    else if(activeIndex == 2) {
        api.execScript({
            frameName: 'message_notice',
            script: 'removeNotice()'
        });
    }
}


// ----------------------------------------------------------------------------------------
/**
 * 新消息提醒
 */
function newMessageNum(msg_type) {
    var user_id = localStorage.getItem("user-id");
    var count = null,
        comment_num = null,
        praise_num = null,
        badge_comment = null,
        badge_praise = null;
    api.ajax({
        url: config.dev_url + 'message/find_num',
        method: 'post',
        data: {
            values: {
                user_id: user_id,
                msg_type: msg_type,
            }
        }
    }, function(ret, err) {
        if (ret.status == 0) {
            if (msg_type == 1) {
                comment_num = $api.getStorage('comment_count');
                if (comment_num == null || ret.num == comment_num) {
                    $api.setStorage('comment_count');
                    return false;
                } else if (ret.num > comment_num) { // 如果新增消息就执行
                    count = ret.num - comment_num; // 计数差值
                    if (count > 0) {
                        badge_comment = $api.dom('#badge-num .badge-comment');
                        badge_comment.innerHTML = count;
                        badge_comment.style.display = 'block';
                    }
                }
                $api.setStorage('commentMessageNum', ret.num);
            } else if(msg_type == 2) {
                praise_num = $api.getStorage('praise_count');
                if (praise_num == null || ret.num == praise_num) {
                    $api.setStorage('praise_count');
                    return false;
                } else if (ret.num > praise_num) { // 如果新增消息就执行
                    count = ret.num - praise_num; // 计数差值
                    if (count > 0) {
                        badge_praise = $api.dom('#badge-num .badge-praise');
                        badge_praise.innerHTML = count;
                        badge_praise.style.display = 'block';
                    }
                }
                $api.setStorage('praiseMessageNum', ret.num);
            }/* else if(msg_type == 4) {
                num = $api.getStorage('notice_count');
                if (num == undefined || ret.num == num) {
                    return false;
                } else if (ret.num > num) { // 如果新增消息就执行
                    count = ret.num - num; // 计数差值
                    $api.append($api.byId('badge-num'), '<div id="badge_notice" class="aui-badge badge-notice">'+count+'</div>');
                }
                $api.setStorage('noticeMessageNum', ret.num);
            }*/
        }
    });
}